

c Define common block containing all coupling constants and masses
c  which are used in the HELAS routines.
c
c  These include masses, widths and real/complex couplings.
c
c  This file can be built automatically from particles.dat and
c  interactions.dat
c
c====================================================================
c
c
c
c     QCD 
c
      double complex       gg(2)
      double precision     g
      common /COUPL_QCD/   g,gg   
c
c    kinematical masses
c
      double precision     hmass, wmass, zmass, amass,
     &                     tmass, bmass, lmass, cmass
      common /COUPL_MASS/  hmass, wmass, zmass, amass,
     &                     tmass, bmass, lmass, cmass
c
c   widths
c
      double precision     hwidth, wwidth, zwidth, 
     &                     twidth, lwidth, awidth
      common /COUPL_WIDTH/ hwidth, wwidth, zwidth, 
     &                     twidth, lwidth, awidth
c
c  couplings in the feynman rules
c
      double complex       gal(2), gad(2), gau(2), gwf(2),
     &                     gzn(2), gzl(2), gzd(2), gzu(2)
      double precision     gw, gwwa, gwwz
      common /COUPL_GAUGE/ gal   , gad   , gau   , gwf   ,
     &                     gzn   , gzl   , gzd   , gzu   ,
     &                     gw, gwwa, gwwz
c
      double complex       gwfc(2),  gwfs(2), gwfm(2)
      common /coupl_ckm/   gwfc,     gwfs   , gwfm	
c
      double complex       gwwh, gzzh, gwwhh, gzzhh, ghhh, ghhhh
      common /COUPL_SCAL/  gwwh, gzzh, gwwhh, gzzhh, ghhh, ghhhh
c
      double complex       ghtop(2), ghbot(2), ghtau(2), ghcha(2)
      common /COUPL_YUK/   ghtop   , ghbot   , ghtau   , ghcha


      double complex Ggrq(2),Ggrb(2),Ggrt(2),Ggrgg(2),Gs2g(2),Gs2q(2),Gs2b(2),Gs2t(2)
      double complex   Gs0t(2),Gs0g(2),Gs1D(2),Gs1U(2),Gs1L(2),Gs1N(2),Go1D(2),Go1U(2)
      common /DC_COUPL/ Gs0t,Gs0g,Gs1D,Gs1U,Gs1L,Gs1N,Go1D,Go1U
     &                 ,Ggrq,Ggrb,Ggrt,Ggrgg,Gs2g,Gs2q,Gs2b,Gs2t
      double precision S0MASS,S1MASS,O1MASS,S2MASS,
     &g1mass,g2mass,g3mass,g4mass,g5mass,g6mass,g7mass,g8mass,g9mass,g0mass
      double precision S0WIDTH,S1WIDTH,O1WIDTH,S2WIDTH,
     &g1width,g2width,g3width,g4width,g5width,g6width,g7width,g8width,g9width,g0width
      common /USR_MASS/  S0MASS,S1MASS,O1MASS,S2MASS,
     &g1mass,g2mass,g3mass,g4mass,g5mass,g6mass,g7mass,g8mass,g9mass,g0mass
      common /USR_DECAY/ S0WIDTH,S1WIDTH,O1WIDTH,S2WIDTH,
     &g1width,g2width,g3width,g4width,g5width,g6width,g7width,g8width,g9width,g0width
      double precision s0scalarf  ,s0axialf   ,s1quleft   ,s1quright  ,s1qdleft   ,s1qdright  ,s1lleft    ,s1l
     +right   ,s1neu      ,o1quleft   ,o1quright  ,o1qdleft   ,o1qdright  ,kapMpl     ,addn       ,mstring    
