      subroutine addmothers(ip,jpart,pb,isym,jsym,rscale,aqcd,aqed,buff,npart)

      implicit none
      include 'genps.inc'
      include 'coupl.inc'
      include 'cluster.inc'
      include 'message.inc'
      include 'run.inc'
      include 'coloramps.inc'
      integer    maxflow
      parameter (maxflow=999)

      integer jpart(7,-nexternal+3:2*nexternal-3),npart,ip
      double precision pb(0:4,-nexternal+3:2*nexternal-3)
      double precision rscale,aqcd,aqed,targetamp(maxamps)
      character*140 buff

      integer isym(nexternal,99), jsym
      integer i,j,k,ida(2),ns,nres,ires,icl,ito2,idenpart,nc,ic
      integer ito(-nexternal+3:nexternal),iseed
      integer icolalt(2,-nexternal+3:2*nexternal-3)
      double precision qicl(-nexternal+3:2*nexternal-3), factpm
      double precision xtarget
      data iseed/-1/

      double precision ZERO
      parameter (ZERO=0d0)
      double precision pmass(-nexternal:0,lmaxconfigs)
      double precision pwidth(-nexternal:0,lmaxconfigs)
      integer pow(-nexternal:0,lmaxconfigs)
      logical first_time,usecolalt
      save pmass,pwidth,pow
      data first_time /.true./

      Double Precision amp2(maxamps), jamp2(0:maxamps)
      common/to_amps/  amp2,       jamp2

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig
      integer idmap(-nexternal:nexternal),icmp

      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest
      integer sprop(-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      common/to_sprop/sprop,tprid
      integer            mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config
      integer iconfig,igraph

      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)
      include 'leshouche.inc'
      
      logical             OnBW(-nexternal:0)     !Set if event is on B.W.
      common/to_BWEvents/ OnBW

c      integer ncols,ncolflow(maxamps),ncolalt(maxamps),icorg
c      common/to_colstats/ncols,ncolflow,ncolalt,icorg

      double precision pt,ran1
      external pt,ran1

      if (first_time) then
         include 'props.inc'
         first_time=.false.
      endif

      npart = nexternal
      buff = ' '
c   
c   Choose the config (diagram) which was actually used to produce the event
c   
      iconfig=mincfig
      if(maxcfig-mincfig.ne.0) then
        write(*,*) 'Error! Cannot cmaxcfig != mincfig: ',maxcfig,mincfig
        return
      endif

c   ...unless the diagram is passed in igscl(1); then use that diagram
      if (igscl(0).ne.0) then
        if (btest(mlevel,3)) then
          write(*,*)'unwgt.f: write out diagram ',igscl(1)
        endif
        iconfig=igscl(1)
      endif
      
c
c    Choose a color flow which is certain to work with the propagator
c    structure of the chosen diagram and use that as an alternative
c   
      igraph=mapconfig(iconfig)

      nc = jamp2(0)
      if(nc.gt.0)then
      if(icolamp(igraph,1)) then
        targetamp(1)=jamp2(1)
c        print *,'Color flow 1 allowed for graph ',igraph
      else
        targetamp(1)=0d0
      endif
      do ic =2,nc
        if(icolamp(igraph,ic))then
          targetamp(ic) = jamp2(ic)+targetamp(ic-1)
c          print *,'Color flow ',ic,' allowed for graph ',igraph
        else
          targetamp(ic)=targetamp(ic-1)
        endif
      enddo
      xtarget=ran1(iseed)*targetamp(nc)

      ic = 1
      do while (targetamp(ic) .lt. xtarget .and. ic .lt. nc)
         ic=ic+1
      enddo
c      print *,'Chose color flow ',ic

      if(targetamp(nc).eq.0) ic=0
      do i=1,nexternal
         if(ic.gt.0) then
            icolalt(1,isym(i,jsym))=icolup(1,i,ic)
            icolalt(2,isym(i,jsym))=icolup(2,i,ic)
         else
            icolalt(1,i)=jpart(4,i)
            icolalt(2,i)=jpart(5,i)
         endif
      enddo

      else ! nc.gt.0

      do i=1,nexternal
         icolalt(1,i)=0
         icolalt(2,i)=0
      enddo

      endif ! nc.gt.0

      if(ickkw.eq.0)then
        usecolalt=.true.
      else
        usecolalt=.false.
      endif
c     
c     Get mother information from chosen graph
c     

c     First check number of resonant s-channel propagators
        ns=0
        nres=0

c     Loop over propagators to find mother-daughter information
        do i=-1,-nexternal+3,-1
c       Daughters
          ida(1)=iforest(1,i,iconfig)
          ida(2)=iforest(2,i,iconfig)
          do j=1,2
            if(ida(j).gt.0) ida(j)=isym(ida(j),jsym)
          enddo
c       Decide s- or t-channel
          if(iabs(sprop(i,iconfig)).gt.0) then ! s-channel propagator
            jpart(1,i)=sprop(i,iconfig)
            ns=ns+1
          else
c         Don't care about t-channel propagators
            goto 100
          endif
c       Set status codes for propagator
          if((igscl(0).ne.0.and.
     $       (iabs(jpart(1,i)).gt.5.and.iabs(jpart(1,i)).lt.11).or.
     $       (iabs(jpart(1,i)).gt.16.and.iabs(jpart(1,i)).ne.21)).or.
     $       (igscl(0).eq.0.and.OnBW(i))) then 
c         Resonance whose mass should be preserved
            jpart(6,i)=2
            nres=nres+1
          else
c         Propagator for documentation only - not included
            jpart(6,i)=3
          endif
c       Calculate momentum (p1+p2 for s-channel, p2-p1 for t-channel)
          do j=0,3
            pb(j,i)=pb(j,ida(1))+pb(j,ida(2))
          enddo
          pb(4,i)=sqrt(max(0d0,pb(0,i)**2-pb(1,i)**2-pb(2,i)**2-pb(3,i)**2))
          if(jpart(6,i).eq.2.and.
     $       abs(pb(4,i)-pmass(i,iconfig)).gt.5d0*pwidth(i,iconfig)) then
            jpart(6,i)=3
            nres=nres-1
          endif
c     Remove propagator if "decay" to same particle (i.e. radiation of g/gamma/higgs)
          if(jpart(6,i).eq.2 .and. (jpart(1,i).eq.jpart(1,ida(1)).or.
     $         jpart(1,i).eq.jpart(1,ida(2)))) then
             if(jpart(1,i).eq.jpart(1,ida(1))) idenpart=ida(1)
             if(jpart(1,i).eq.jpart(1,ida(2))) idenpart=ida(2)
c     Always remove if daughter final-state or already removed for this reason
             if(idenpart.gt.0.or.jpart(6,idenpart).eq.4) then
                jpart(6,i)=4
                nres=nres-1
c     Else remove either this resonance or daughter, which is closer to mass shell
             elseif(abs(pb(4,i)-pmass(i,iconfig)).gt.
     $               abs(pb(4,idenpart)-pmass(i,iconfig))) then
                jpart(6,i)=4
                nres=nres-1
             else if(jpart(6,idenpart).eq.2) then
                jpart(6,idenpart)=4
                nres=nres-1
             endif
          endif
c       Set color info for all s-channels
c       Fist set "safe" color info
          if(icolalt(1,ida(1))+icolalt(1,ida(2))-
     $       icolalt(2,ida(1))-icolalt(2,ida(2)).eq.0) then ! color singlet
            icolalt(1,i) = 0
            icolalt(2,i) = 0            
          elseif(icolalt(1,ida(1))-icolalt(2,ida(2)).eq.0) then
            icolalt(1,i) = icolalt(1,ida(2))
            icolalt(2,i) = icolalt(2,ida(1))
          else if(icolalt(1,ida(2))-icolalt(2,ida(1)).eq.0) then
            icolalt(1,i) = icolalt(1,ida(1))
            icolalt(2,i) = icolalt(2,ida(2))
          else if(jpart(6,i).ge.3) then ! Don't need to match
            icolalt(1,i) = icolalt(1,ida(1))+icolalt(1,ida(2))
            icolalt(2,i) = icolalt(2,ida(1))+icolalt(2,ida(2))
          else
c         Erraneous color assignment for propagator
            goto 90
          endif
c       Now try default color assignment (only in matching case)
          if(.not.usecolalt)then
          if(jpart(4,ida(1))+jpart(4,ida(2))-
     $       jpart(5,ida(1))-jpart(5,ida(2)).eq.0) then ! color singlet
            jpart(4,i) = 0
            jpart(5,i) = 0            
          elseif(jpart(4,ida(1))-jpart(5,ida(2)).eq.0) then
            jpart(4,i) = jpart(4,ida(2))
            jpart(5,i) = jpart(5,ida(1))
          else if(jpart(4,ida(2))-jpart(5,ida(1)).eq.0) then
            jpart(4,i) = jpart(4,ida(1))
            jpart(5,i) = jpart(5,ida(2))
          else if(jpart(6,i).ge.3) then ! Don't need to match
            jpart(4,i) = jpart(4,ida(1))+jpart(4,ida(2))
            jpart(5,i) = jpart(5,ida(1))+jpart(5,ida(2))
          else
c         Erraneous color assignment for propagator
c          print *,'colors:',jpart(4,ida(1)),jpart(5,ida(1)),jpart(4,ida(2)),jpart(5,ida(2))
             usecolalt=.true.
          endif
          endif ! .not.usecolalt
c       Check color assignment for propagator by particle id (ugly!)
          if(jpart(6,i).eq.2.and..not.usecolalt)then
            if(iabs(mod(jpart(1,i),1000000)).le.8) then ! quark or squark
              if(jpart(1,i).gt.0.and.(jpart(4,i).eq.0.or.jpart(5,i).ne.0)) usecolalt=.true.
              if(jpart(1,i).lt.0.and.(jpart(5,i).eq.0.or.jpart(4,i).ne.0)) usecolalt=.true.
            else if(mod(jpart(1,i),1000000).eq.21) then ! gluino
              if(jpart(5,i).eq.0.or.jpart(4,i).eq.0) usecolalt=.true.
            else                ! color singlet
              if(jpart(5,i).ne.0.or.jpart(4,i).ne.0) usecolalt=.true.
            endif
          endif
          if(jpart(6,i).eq.2.and.usecolalt)then
            if(iabs(mod(jpart(1,i),1000000)).le.8) then ! quark or squark
              if(jpart(1,i).gt.0.and.(icolalt(1,i).eq.0.or.icolalt(2,i).ne.0)) goto 90
              if(jpart(1,i).lt.0.and.(icolalt(2,i).eq.0.or.icolalt(1,i).ne.0)) goto 90
            else if(mod(jpart(1,i),1000000).eq.21) then ! gluino
              if(icolalt(2,i).eq.0.or.icolalt(1,i).eq.0) goto 90
            else               ! color singlet
              if(icolalt(2,i).ne.0.or.icolalt(1,i).ne.0) goto 90
            endif
          endif
c         Set tentative mothers
          jpart(2,i) = 1
          jpart(3,i) = 2
c         Set mother info for daughters
          do j=1,2
            jpart(2,ida(j)) = i
            jpart(3,ida(j)) = i
          enddo
c       Just zero helicity info for intermediate states
          jpart(7,i) = 0
        enddo                   ! do i
        goto 100                ! only s-channel propagators found
 90     continue
c     Propagator not compatible with color flow -> remove the propagator
        print *,'ERROR: Safe color assignment wrong! This should never happen!'

        if(jpart(6,i).eq.2) then
           nres=nres-1
           jpart(6,i)=3
        endif

c        print *,'Diagram: ',igraph,', Color flow: ',ic
c        print *,'colors:',icolalt(1,ida(1)),icolalt(2,ida(1)),
c     $     icolalt(1,ida(2)),icolalt(2,ida(2))
c        write(*,'(15i5)'),(jpart(1,j),j=1,nexternal),(jpart(1,j),j=-1,i,-1)
c        write(*,'(15i5)'),(jpart(2,j),j=1,nexternal),(jpart(2,j),j=-1,i,-1)
c        write(*,'(15i5)'),(jpart(3,j),j=1,nexternal),(jpart(3,j),j=-1,i,-1)
c        write(*,'(15i5)'),(icolalt(1,j),j=1,nexternal),(icolalt(1,j),j=-1,i,-1)
c        write(*,'(15i5)'),(icolalt(2,j),j=1,nexternal),(icolalt(2,j),j=-1,i,-1)
c        write(*,'(15i5)'),(jpart(6,j),j=1,nexternal),(jpart(6,j),j=-1,i,-1)
c        write(*,'(15f5.0)'),(pb(4,j),j=1,nexternal),(pb(4,j),j=-1,i,-1)
c        STOP
 100    continue

c        if(usecolalt)then
c          print *,'Default colors didn''t fit, use safe colors'
c          write(*,'(15i5)'),(jpart(1,j),j=1,nexternal),(jpart(1,j),j=-1,i,-1)
c          write(*,'(15i5)'),(jpart(2,j),j=1,nexternal),(jpart(2,j),j=-1,i,-1)
c          write(*,'(15i5)'),(jpart(3,j),j=1,nexternal),(jpart(3,j),j=-1,i,-1)
c          write(*,'(15i5)'),(jpart(4,j),j=1,nexternal),(jpart(4,j),j=-1,i,-1)
c          write(*,'(15i5)'),(jpart(5,j),j=1,nexternal),(jpart(5,j),j=-1,i,-1)
c          write(*,'(15i5)'),(icolalt(1,j),j=1,nexternal),(icolalt(1,j),j=-1,i,-1)
c          write(*,'(15i5)'),(icolalt(2,j),j=1,nexternal),(icolalt(2,j),j=-1,i,-1)
c          write(*,'(15i5)'),(jpart(6,j),j=1,nexternal),(jpart(6,j),j=-1,i,-1)
c          write(*,'(15f5.0)'),(pb(4,j),j=1,nexternal),(pb(4,j),j=-1,i,-1)
c        endif

c        if(usecolalt)then
c           ncolalt(ic)=ncolalt(ic)+1
c        else
c           ncolalt(icorg)=ncolalt(icorg)+1
c        endif

c    Remove non-resonant mothers, set position of particles
        ires=0
        do i=-ns,nexternal
          if(usecolalt)then
            jpart(4,i)=icolalt(1,i)
            jpart(5,i)=icolalt(2,i)
          endif
          if(i.eq.1.or.i.eq.2) then 
            ito(i)=i            ! initial state particle
          else if(i.ge.3) then 
            ito(i)=i+nres       ! final state particle
          else if(i.le.-1.and.jpart(6,i).eq.2) then
            ires=ires+1
            ito(i)=2+ires       ! s-channel resonances
          else 
            ito(i)=0
            if(i.eq.0) cycle
          endif
          if(jpart(2,i).lt.0.and.jpart(6,jpart(2,i)).ne.2) then
            jpart(2,i)=jpart(2,jpart(2,i))
            jpart(3,i)=jpart(3,jpart(3,i))
          endif
        enddo
        
c
c    Shift particles to right place and set mothers of particles
c
        do i=nexternal,-ns,-1
          if(ito(i).le.0) cycle
          do j=1,7
            jpart(j,ito(i))=jpart(j,i)
          enddo
          if(jpart(2,ito(i)).lt.0) then
            jpart(2,ito(i))=ito(jpart(2,ito(i)))
            jpart(3,ito(i))=ito(jpart(3,ito(i)))
          endif
          do j=0,4
            pb(j,ito(i))=pb(j,i)
          enddo
        enddo

        if(ickkw.gt.0)
     $       write(buff,'(a1,9e15.7)') '#',(ptclus(i),i=3,min(nexternal,11))
        npart = nexternal+nres

      return
      end
