      SUBROUTINE SETCUTS
C**************************************************************************
C     SET THE CUTS 
C**************************************************************************
      IMPLICIT NONE
c
c     INCLUDE
c
      include 'genps.inc'
      include 'coupl.inc'
      include 'run.inc'
c
c     Constants
c
      double precision zero
      parameter       (ZERO = 0d0)
      real*8 Pi
      parameter( Pi = 3.14159265358979323846d0 )
      integer    lun
      parameter (lun=22)
c
c     LOCAL
c
      integer i,j
      integer icollider,detail_level
      logical  do_cuts(nexternal)
      integer ncheck
      logical done,fopened
C     
C     GLOBAL
C
c--masses and poles
      double precision pmass(nexternal)
      common/to_mass/  pmass
      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole          ,swidth          ,bwjac
c--cuts
      double precision etmin(nincoming+1:nexternal),etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)

      common/to_cuts/  etmin, emin, etamax, r2min, s_min

c
c     les houches accord stuff to indentify neutrinos
c
      integer    maxflow
      parameter (maxflow=999)
      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)
      include 'leshouche.inc'
C
C     AUTOMATIC CUTS
C
      REAL*8 PTJ,PTB,PTA,PTL
      REAL*8 EJ,EB,EA,EL
      REAL*8 ETAJ,ETAB,ETAA,ETAL
      REAL*8 DRJJ,DRBB,DRLL,DRAA,DRBJ,DRAJ,DRJL,DRAB,DRBL,DRAL
      REAL*8 MMJJ,MMLL,MMAA,MMBB
      COMMON /TO_AUTO_CUTS/
     &     PTJ,PTB,PTA,PTL,EJ,EB,EA,EL,
     &     ETAJ,ETAB,ETAA,ETAL,
     &     DRJJ,DRBB,DRLL,DRAA,DRBJ,DRAJ,DRJL,DRAB,DRBL,DRAL,
     &     MMJJ,MMLL,MMAA,MMBB

C     
C     SPECIAL CUTS
C
      REAL*8 XPTJ,XPTB,XPTA,XPTL
      REAL*8 XETAMIN,XQCUT,deltaeta
      COMMON /TO_SPECXPT/XPTJ,XPTB,XPTA,XPTL,XETAMIN,XQCUT,deltaeta
      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B
c
c
c     reading parameters
      integer maxpara
      parameter (maxpara=100)
      character*20 param(maxpara),value(maxpara)
      integer npara
c
c     setup masses for the final-state particles
c
      include 'pmass.inc'

C-----
C  BEGIN CODE
C-----
c
c     read the cuts from the run_card.dat - this should already be done in main program
c
c      call setrun

c
c     No pdfs for decay processes - set here since here we know the nincoming
c     Also set stot here, and use mass of incoming particle for ren scale
c
         if(nincoming.eq.1)then
            lpp(1)=0
            lpp(2)=0
            ebeam(1)=pmass(1)/2d0
            ebeam(2)=pmass(1)/2d0
            scale=pmass(1)
            fixed_ren_scale=.true.
         endif

c
c     check if I have to apply cuts on the particles
c
      do i=nincoming+1,nexternal
         do_cuts(i)=.true.
         if(nincoming.eq.1) do_cuts(i)=.false.
         is_a_j(i)=.false.
         is_a_l(i)=.false.
         is_a_b(i)=.false.
         is_a_a(i)=.false.

c-do not apply cuts to these
         if (pmass(i).gt.10d0)     do_cuts(i)=.false.  ! no cuts on top,W,Z,H
         if (abs(idup(i,1)).eq.12) do_cuts(i)=.false.  ! no cuts on ve ve~
         if (abs(idup(i,1)).eq.14) do_cuts(i)=.false.  ! no cuts on vm vm~
         if (abs(idup(i,1)).eq.16) do_cuts(i)=.false.  ! no cuts on vt vt~

c-jets
         if (abs(idup(i,1)).eq.1 )  is_a_j(i)=.true. ! d and d~ are jets
         if (abs(idup(i,1)).eq.2 )  is_a_j(i)=.true. ! u and u~ are jets
         if (abs(idup(i,1)).eq.3 )  is_a_j(i)=.true. ! s and s~ are jets
         if (abs(idup(i,1)).eq.4 )  is_a_j(i)=.true. ! c and c~ are jets
         if (abs(idup(i,1)).eq.21)  is_a_j(i)=.true. ! gluon is a jet
c-charged-leptons
         if (abs(idup(i,1)).eq.11)  is_a_l(i)=.true. ! e+  e-
         if (abs(idup(i,1)).eq.13)  is_a_l(i)=.true. ! mu+ mu-
         if (abs(idup(i,1)).eq.15)  is_a_l(i)=.true. ! ta+ ta-
c-b-quarks
         if (abs(idup(i,1)).eq.5)   is_a_b(i)=.true. ! b b~
c-photon
         if (idup(i,1).eq.22)   is_a_a(i)=.true. ! photon
      enddo
      

c
c     et and eta cuts
c
      do i=nincoming+1,nexternal
         etmin(i)=0d0
         emin(i)=0d0
         etamax(i) = 1d2

         if(do_cuts(i)) then
            if(is_a_j(i)) etmin(i)=ptj
            if(is_a_l(i)) etmin(i)=ptl
            if(is_a_b(i)) etmin(i)=ptb
            if(is_a_a(i)) etmin(i)=pta
c
            if(is_a_j(i)) emin(i)=ej
            if(is_a_l(i)) emin(i)=el
            if(is_a_b(i)) emin(i)=eb
            if(is_a_a(i)) emin(i)=ea

c
            if(is_a_j(i)) etamax(i)=etaj
            if(is_a_l(i)) etamax(i)=etal
            if(is_a_b(i)) etamax(i)=etab
            if(is_a_a(i)) etamax(i)=etaa
         endif
      enddo
c
c     delta r cut
c
      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            r2min(j,i)=0d0
            if(do_cuts(i).and.do_cuts(j)) then
               if(is_a_j(i).and.is_a_j(j)) r2min(j,i)=drjj
               if(is_a_b(i).and.is_a_b(j)) r2min(j,i)=drbb
               if(is_a_l(i).and.is_a_l(j)) r2min(j,i)=drll
               if(is_a_a(i).and.is_a_a(j)) r2min(j,i)=draa
               if((is_a_b(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_b(j))) r2min(j,i)=drbj
               if((is_a_a(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_a(j))) r2min(j,i)=draj
               if((is_a_l(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_l(j))) r2min(j,i)=drjl
               if((is_a_b(i).and.is_a_a(j)).or.
     &           (is_a_a(i).and.is_a_b(j))) r2min(j,i)=drab
               if((is_a_b(i).and.is_a_l(j)).or.
     &           (is_a_l(i).and.is_a_b(j))) r2min(j,i)=drbl
               if((is_a_l(i).and.is_a_a(j)).or.
     &           (is_a_a(i).and.is_a_l(j))) r2min(j,i)=dral
 
            endif
         enddo
      enddo
c     
c     smin cut
c
      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            s_min(j,i)=0.0d0**2
            if(do_cuts(i).and.do_cuts(j)) then
               if(is_a_j(i).and.is_a_j(j)) s_min(j,i)=mmjj*dabs(mmjj)   
               if(is_a_a(i).and.is_a_a(j)) s_min(j,i)=mmaa*dabs(mmaa)  
               if( is_a_b(i).and.is_a_b(j) ) s_min(j,i)=mmbb*dabs(mmbb)     
               if((is_a_l(i).and.is_a_l(j)).and.
     &            (abs(idup(i,1)).eq.abs(idup(j,1))).and.
     &            (idup(i,1)*idup(j,1).lt.0)) s_min(j,i)=mmll*dabs(mmll)  !only on l+l- pairs (same flavour)

            endif
         enddo
      enddo      

c    ERROR TRAPS 
c
        do i=nincoming+1,nexternal
           if(is_a_j(i).and.etmin(i).eq.0.and.emin(i).eq.0) then
              write (*,*) "Warning: pt or E min of a jet should in general be >0"
           endif
           if(is_a_a(i).and.etmin(i).eq.0.and.emin(i).eq.0) then
              write (*,*) "Warning: pt or E min of a gamma should in general be >0"
           endif
        enddo

c    count number of jets to see if special cuts are applicable or not

        ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_j(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xptj .gt. 0d0) then
           write (*,*) "Warning: cuts on the jet will be ignored"
           xptj = 0d0
        endif

        if(ncheck.lt.2.and. xetamin .gt. 0 .and. deltaeta .gt.0) then
           write (*,*) "Warning: WBF cuts not will be ignored"
           xetamin = 0d0
           deltaeta =0d0
        endif

   
c    count number of photons to see if special cuts are applicable or not

        ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_a(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xpta .gt. 0d0) then
           write (*,*) "Warning: cuts on the photon will be ignored"
           xpta =0d0
        endif

c    count number of b-quarks to see if special cuts are applicable or not

        ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_b(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xptb .gt. 0d0) then
           write (*,*) "Warning: cuts on the b-quarks will be ignored"
           xptb = 0d0
        endif

c    count number of leptons to see if special cuts are applicable or not

        ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_l(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xptl .gt. 0d0) then
           write (*,*) "Warning: cuts on the lepton will be ignored"
           xptl = 0d0
        endif

c      call write_cuts()
      RETURN

      END


